using FluentValidation;
using CMSMicroservice.Protobuf.Protos.UserWallet;
namespace CMSMicroservice.Protobuf.Validator.UserWallet;

public class UpdateUserWalletRequestValidator : AbstractValidator<UpdateUserWalletRequest>
{
    public UpdateUserWalletRequestValidator()
    {
        RuleFor(model => model.Id)
            .NotNull();
        RuleFor(model => model.UserId)
            .NotNull();
        RuleFor(model => model.Balance)
            .NotNull();
        RuleFor(model => model.NetworkBalance)
            .NotNull();
    }
    public Func<object, string, Task<IEnumerable<string>>> ValidateValue => async (model, propertyName) =>
    {
        var result = await ValidateAsync(ValidationContext<UpdateUserWalletRequest>.CreateWithOptions((UpdateUserWalletRequest)model, x => x.IncludeProperties(propertyName)));
        if (result.IsValid)
            return Array.Empty<string>();
        return result.Errors.Select(e => e.ErrorMessage);
    };
}
